package cz.muni.pa165.authentication.rest;

import cz.muni.pa165.authentication.data.model.ApiKey;
import cz.muni.pa165.authentication.service.ApiKeyService;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.Date;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.security.oauth2.client.OAuth2AuthorizedClient;
import org.springframework.security.oauth2.client.annotation.RegisteredOAuth2AuthorizedClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(path = "/authenticate")
public class AuthenticationController {

  @Autowired
  ApiKeyService apiKeyService;

  @PostMapping(path = "/create/apikey")
  public ResponseEntity<ApiKey> createApiKey(
      @RegisteredOAuth2AuthorizedClient @Schema(hidden = true)
          OAuth2AuthorizedClient oauth2Client) {

    return ResponseEntity.ok(apiKeyService.createApiKey(ApiKey.builder()
        .encodedValue(oauth2Client.getAccessToken().getTokenValue())
        .expirationDate(new Date())
        .build()));
  }

  @GetMapping(path = "/apikey")
  public ResponseEntity<Boolean> authenticate(@RequestParam String apiKey) {
    return ResponseEntity.ok(apiKeyService.isAuthenticated(apiKey));
  }
}
