package cz.muni.pa165.authentication.service;

import cz.muni.pa165.authentication.data.model.ApiKey;
import cz.muni.pa165.authentication.data.repository.ApiKeyRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ApiKeyService {

  @Autowired
  ApiKeyRepository apiKeyRepository;

  public ApiKey createApiKey(ApiKey apiKey) {
    var generatedApiKey = ApiKeyUtil.generateApiKey(apiKey.getEncodedValue());
    apiKey.setEncodedValue(ApiKeyUtil.encryptApiKey(generatedApiKey));

    var savedApiKey = apiKeyRepository.save(apiKey);
    savedApiKey.setEncodedValue(ApiKeyUtil.decryptApiKey(savedApiKey.getEncodedValue()));
    return savedApiKey;
  }

  public Boolean isAuthenticated(String apiKey) {
    var foundApiKey = apiKeyRepository.findByKey(ApiKeyUtil.encryptApiKey(apiKey));
    if (foundApiKey != null) {
      return Boolean.TRUE;
    }
    return Boolean.FALSE;
  }
}
