package cz.muni.pa165.race;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

@Component
public class ApiKeyAuthManager implements AuthenticationManager {

  private final RestTemplate client = new RestTemplate();

  @Value("${server.services.authentication.port}")
  private String authenticationPort;

  @Override
  public Authentication authenticate(Authentication authentication) throws AuthenticationException {

    final String apiKey = (String) authentication.getPrincipal();
    String url = "http://" + "localhost" + ":" + authenticationPort + "/authenticate/apikey?apiKey="
        + apiKey;
    var res = client.getForEntity(url, Boolean.class);

    if (res.getBody()) {
      authentication.setAuthenticated(true);
    } else {
      throw new BadCredentialsException("The API key was not found or not the expected value.");
    }
    return authentication;
  }
}
